<template>
  <q-card class="c-col h-full">
    <q-card-section class="bg-deep-orange text-white">
      <div class="text-24px">
        點選要預覽的班表
      </div>
    </q-card-section>
    <q-card-section class="bg-grey-1 w-400px">
      <q-list dense>
        <q-item>
          <q-item-section>
            <q-item-label caption>
              快速搜尋
            </q-item-label>
          </q-item-section>
        </q-item>
        <q-item>
          <q-item-section>
            <q-input
              v-model="query.key"
              label="關鍵字"
              filled
              dense
              clearable
            />
          </q-item-section>
        </q-item>
        <q-item>
          <q-item-section>
            <q-input
              v-model="query.year"
              class="flex-1"
              label="年份"
              filled
              dense
              clearable
            />
          </q-item-section>
          <q-item-section>
            <q-input
              v-model="query.month"
              class="flex-1"
              label="月份"
              filled
              dense
              clearable
            />
          </q-item-section>
        </q-item>
      </q-list>
    </q-card-section>
    <div class="c-col h-600px p-10px">
      <div
        v-if="classSchedules.length === 0"
        class="text-red text-center bg-red-1 p-10px"
      >
        無班表資料
      </div>
      <div
        v-else-if="list.length === 0"
        class="text-red text-center bg-red-1 p-10px"
      >
        無符合搜尋條件之班表
      </div>
      <q-scroll-area
        v-else
        class="h-full"
      >
        <div
          v-for="{ classSchedule, isSelected } in list"
          :key="classSchedule.month"
          class="item"
          :class="{ selected: isSelected }"
          @click="setSelected(classSchedule)"
        >
          <q-chip>{{ classSchedule.month }}</q-chip>
          <div class="text-16px ml-10px">
            {{ classSchedule.name }}
          </div>
          <div class="c-row w-full justify-end">
            <q-btn
              icon="delete"
              flat
              rounded
              @click.stop="submitDelete(classSchedule)"
            />
          </div>
        </div>
      </q-scroll-area>
    </div>
  </q-card>
</template>

<script lang='ts' setup>
import dayjs from 'dayjs';
import { cloneDeep } from 'lodash';
import { computed, reactive, ref } from 'vue';
import { ClassSchedule } from '../types/main.type';

import { useMainStore } from '../store/main.store';
import { useQuasar } from 'quasar';

interface Props {
  classSchedule?: ClassSchedule;
}

const props = withDefaults(defineProps<Props>(), {
  classSchedule: undefined,
});

const emit = defineEmits<{
  (e: 'selected', value: ClassSchedule | undefined): void;
}>();

const $q = useQuasar();
const store = useMainStore();

const query = reactive({
  key: null,
  year: null,
  month: null,
});

const selectedClassSchedules = ref(props.classSchedule);

const setSelected = (classSchedule: ClassSchedule) => {
  if (
    selectedClassSchedules.value?.name === classSchedule.name &&
    selectedClassSchedules.value?.month === classSchedule.month
  ) {
    selectedClassSchedules.value = undefined;
    emit('selected', undefined);
    return;
  }

  selectedClassSchedules.value = classSchedule;
  emit('selected', cloneDeep(classSchedule));
};

const classSchedules = computed(() => store.classSchedules);

const list = computed(() => {
  let result = classSchedules.value.map((classSchedule) => {
    const isSelected =
      selectedClassSchedules.value?.name === classSchedule.name &&
      selectedClassSchedules.value?.month === classSchedule.month;

    return {
      classSchedule,
      isSelected,
    };
  });

  if (query.key) {
    result = result.filter(({ classSchedule }) => {
      return classSchedule.name.includes(`${query.key}`);
    });
  }

  if (query.year) {
    result = result.filter(({ classSchedule }) => {
      const scheduleDate = dayjs(`${classSchedule.month}/01`);
      return scheduleDate.year() === parseInt(query.year!, 10);
    });
  }

  if (query.month) {
    result = result.filter(({ classSchedule }) => {
      const scheduleDate = dayjs(`${classSchedule.month}/01`);
      return scheduleDate.month() + 1 === parseInt(query.month!, 10);
    });
  }

  return result;
});
const submitDelete = (classSchedule: ClassSchedule) => {
  $q.notify({
    type: 'warning',
    message: `確定刪除「${classSchedule.month}-${classSchedule.name}」此班表嗎？`,
    progress: true,
    actions: [
      {
        label: '確認',
        color: 'white',
        handler: () => {
          store.removeClassSchedule(classSchedule);

          selectedClassSchedules.value = undefined;
          emit('selected', undefined);
        },
      },
      {
        label: '取消',
        color: 'white',
        class: 'bg-deep-orange',
        handler: () => {
          /* ... */
        },
      },
    ],
  });
};
</script>

<style scoped lang='sass'>

@import '../styles/quasar.variables.sass'

.item
  display: flex
  align-items: center
  background: rgba(#000, 0.05)
  margin-bottom: 5px
  padding: 5px
  transition-duration: 0.4s
  cursor: pointer
  &:hover
    background: rgba(#000, 0.2)
  &.selected
    background: $deep-orange
    color: white
</style>
